---

  - block:

    - name: "check local release exists"
      local_action: stat path=$PWD/{{ local_release }}
      register: local_release_file

    - name: "set src to {{ local_release }}"
      set_fact:
        app_src: "{{ local_release }}"
      when: local_release_file.stat.exists

    - name: "create temporary download directory for archive"
      tempfile:
        state: directory
        suffix: "_app_new"
      register: _tmp_new_app
      changed_when: False

    - name: "check {{ app_instance_root }} exists"
      stat:
        path: "{{ app_instance_root }}"
      register: instance_root_dir

    - name: "retrieving app from {{ app_src }}"
      unarchive:
        src: "{{ app_src }}"
        dest: "{{ _tmp_new_app.path }}"
        remote_src: "{{ not(local_release_file.stat.exists) }}"
      when: (app_run == 'upgrade') or (app_run in ['install', 'reinstall'] and not(instance_root_dir.stat.exists))

    - name: "chown / chgrp {{ app_user }} / {{ app_group }}"
      file:
        dest: "{{ _tmp_new_app.path }}"
        owner: "{{ app_user | default('www-data') }}"
        group: "{{ app_group | default('www-data') }}"
        recurse: True
      when: app_user is defined

    when: app_src != ""
